////////////////////////////////////////////////
//                                            //
// SMSWrite version 0.3 - 27/10/2000          //
//                                            //
// Mike Gordon                                //
//                                            //
// mike@mikeg2.freeserve.co.uk                //
//                                            //
////////////////////////////////////////////////

#define True -1
#define False 0

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


typedef enum
{
	CT_A,CT_32,CT_128,CT_256,CT_512,CT_1024,CT_S
}	CARTNAME;


unsigned long ctSize[] = {1048576,32768,131072,262144,524288,1048576,16384};

unsigned char ctMap[]  = { 0x00,  0x00,  0x01,  0x02,  0x02,   0x02, 0x03 };

unsigned char ctBank[] = { 0x00, 0x02,  0x08,  0x10,  0x20,   0x40, 0x01 };

const char *ctType[] = { "a","32","128","256","512","1024","s" };


CARTNAME sgCart = CT_A;
unsigned char rdMode = True;
unsigned char patch  = True;
unsigned char doSum  = True;
unsigned char *fBuf;
unsigned short int portAddr = 0x378;
unsigned short int counter = 0;
unsigned char speed = 0x04;
unsigned long period = 0;
unsigned long fileLength;
unsigned char verify = 1;
unsigned char map = 0x05;
unsigned long m;
char fileName[600] = "";


void sgReset(void);
void sgCount(unsigned short int value);
unsigned char sgRead(unsigned short int data);
void sgWrite(unsigned short int value, unsigned char data);
void sgWait(void);
void sgInsert(void);
void sgRemove(void);
void sgCheck(void);
void mapZero(unsigned char bank);
void mapOne(unsigned char bank);
void mapTwo(unsigned char bank);
void mapSram(void);
void fileEnter(void);
void stripHeader(void);
void sgSwitchOn(void);
void sgSwitchOff(void);


int main(int argc, char *argv[])
{

	int i;
	char argsTrue = 0;
	
        FILE *fp;

	printf("\n\n SMSWRITE version 0.3, (c) 2000 Mike Gordon.\n");
	printf("=============================================\n\n");



	argsTrue = True;

	for (i=1 ; (i<argc) && argsTrue; i=i+1)
	{

		strlwr(argv[i]);

		
		if ((argv[i][0] == '/')||(argv[i][0] == '-'))
		{
			
			if (strlen(argv[i]) < 2)
				argsTrue = False;

			else if (argv[i][1] == 'p')
			{
				portAddr = (unsigned short int) strtol(argv[i]+2,NULL,16);
				if (portAddr != 0x278 && portAddr != 0x378 && portAddr != 0x3BC)
				{
					portAddr = 0x378;
				}
			}

			else if (argv[i][1] == 's') 
			{
				int g=strtol(argv[i]+2,NULL,10);

				if( (g>=0) && (g<=9) )
					speed=g;
					
			}

			else if (argv[i][1] == 'm') 
			{
				int g=strtol(argv[i]+2,NULL,10);

				if( (g>=0) && (g<=2) )
					map=g;
					
			}

			else if (argv[i][1] == 'v') 
			{
				int g=strtol(argv[i]+2,NULL,10);

				if( (g>=0) && (g<=1) )
					verify=g;
					
			}

			else if (argv[i][1] == 'k') 
			{
				int g=strtol(argv[i]+2,NULL,10);
				if(g==0)
				{
					doSum=False;
					patch=False;
				}
				else if(g==1)
				{
					doSum=True;
					patch=False;
				}
				else
				{
					doSum=True;

					patch=True;
				}			
			}
			


			else if (argv[i][1] == 'c')
			{
				while (strcmp(ctType[sgCart],argv[i]+2) && sgCart <= CT_S)
					sgCart++;

				if (strcmp(ctType[sgCart],argv[i]+2))
				{
					printf("ERROR! Please specify a valid cartridge type.\n\n");
					exit(1);
				}
			}
			
			else
				argsTrue = False;
		}


		else
		{
			if (!strlen(fileName))
				strcpy(fileName,argv[i]);
			
		}

	}

	if ((!strlen(fileName)) && argsTrue)
		fileEnter();

	if (!argsTrue)
	{

		printf("COMMAND SYNTAX :\n\n");

		printf("      smswrite [<options>] [<filename>]\n\n");

		printf("See SMSCMD.TXT for details of command line options.\n\n\n");

		return 0;

	}


	fp=fopen(fileName,"rb");

	if (fp == NULL)
	{
		printf("ERROR! File %s does not exist.\n\n",fileName);
		exit(1);
	}

	fseek(fp,0L,SEEK_END);

	fileLength=ftell(fp);

	if(sgCart==CT_A)
	{
		if((fileLength>=0)&&(fileLength<=33350))
		{
			sgCart=CT_32;
		}
		else if((fileLength>33350)&&(fileLength<=131654))
		{
			sgCart=CT_128;
		}
		else if((fileLength>131654)&&(fileLength<=262726))
		{
			sgCart=CT_256;
		}
		else if((fileLength>262726)&&(fileLength<=524870))
		{
			sgCart=CT_512;
		}
		else if((fileLength>524870)&&(fileLength<=1049158))
		{
			sgCart=CT_1024;
		}
		else
		{
			fclose(fp);
			printf("ERROR! File %s is too big.\n\n",fileName);
			exit(1);
		}

	}

	if (fileLength > ((ctSize[sgCart])+582))
	{
			fclose(fp);
			printf("ERROR! File %s is too big.\n\n",fileName);
			exit(1);
	}

	fBuf = malloc((ctSize[sgCart])+582);

	if (fBuf == NULL)
	{
		fclose(fp);
		printf("ERROR! Not enough memory.\n\n");
		exit(1);
	}

	memset (fBuf,0x00,(ctSize[sgCart])+582);

	fseek(fp,0L,SEEK_SET);

	if (fread(fBuf,1,fileLength,fp) != fileLength)
	{
		fclose(fp);
		printf("ERROR! Problem reading file.\n\n");
		exit(1);
	}

	fclose(fp);

	if(map==0x05)
		map=ctMap[sgCart];

	if(sgCart==CT_S)
		map=0x03;

	
	if(sgCart==CT_S)
	{
		doSum=False;
		patch=False;
	}

	period=1;

	for(i=0;i<speed;i++)
		period=period*5;
	
	
	stripHeader();

	if(doSum)
		sgCheck();
		
	if(sgCart==CT_S)
		printf("Preparing for SRAM write operation on port 0x%03X.\n\n",portAddr);
	else
		printf("Preparing for %dK write operation on port 0x%03X.\n\n",ctSize[sgCart]/1024,portAddr);

	sgInsert();

	if(sgCart!=CT_S)
		sgSwitchOn();


	switch(map)
	{
		case 0x00: mapZero(ctBank[sgCart]); break;
		case 0x01: mapOne(ctBank[sgCart]); break;
		case 0x03: mapSram(); break;
		default: mapTwo(ctBank[sgCart]);
	}

	
	
	fflush(stdout);

	
	if(sgCart==CT_S)
	{
		printf("16KBytes successfully written from saved game file %s.\n\n",fileName);
	}
	else
	{
		printf("%dKBytes successfully written from file %s.\n\n",(ctSize[sgCart]/1024),fileName);
	}
	
	
	fflush(stdout);

	if((!verify)&&(sgCart!=CT_S))
		sgSwitchOff();
	
	sgRemove();

	return False;

}


void sgInsert(void)
{

	outp(portAddr+2,0x24);

	printf("-- INSERT CARTRIDGE AND PRESS A KEY WHEN READY --\n\n");

	fflush(stdout);

	if (!getch()) getch();

}

void sgRemove(void)
{
	sgReset();
	
	outp(portAddr+2,0x24);

	printf("-- PLEASE REMOVE CARTRIDGE --\n\n");

	fflush(stdout);	
}

void sgSwitchOff(void)
{

	printf("Please wait...\n\n");

	if(counter<0xC000ul)
		sgCount(0xC000ul);
	
	
	printf("-- SET WRITE PROTECT SWITCH AND PRESS A KEY WHEN READY --\n\n");

	fflush(stdout);

	if (!getch()) getch();
	
}

void sgSwitchOn(void)
{
		
	printf("-- SET WRITE ENABLE SWITCH AND PRESS A KEY WHEN READY --\n\n");

	fflush(stdout);

	if (!getch()) getch();
	
}

void sgReset(void)
{

			
	sgWait();

	outp(portAddr,0xff);

	sgWait();

	outp(portAddr+2,0x26);

	sgWait();

	outp(portAddr+2,0x24);

	sgWait();

	outp(portAddr+2,0x26);

	sgWait();

	counter = 0;
	
}

void sgCount(unsigned short int value)
{
	
	for(counter=counter;counter!=value;counter++)	
	{
		if (rdMode)
		{
			outp(portAddr+2,0x27);
		}
		else
		{
			outp(portAddr+2,0x0F);
		}

		sgWait();

		if (rdMode)
		{
			outp(portAddr+2,0x26);
		}
		else
		{
			outp(portAddr+2,0x0E);
		}
	
		sgWait();

		counter=(counter & 0x0fffful);

	}

	

}

void sgWrite(unsigned short int value, unsigned char data)
{

	rdMode = False;

	sgCount(value);

	sgWait();

	outp(portAddr+2,0x0E);

	sgWait();

	outp(portAddr,data);
	
	sgWait();

	outp(portAddr+2,0x0A);

	sgWait();

	outp(portAddr+2,0x0E);

	sgWait();

	rdMode = True;

	
}

unsigned char sgRead(unsigned short int value)
{

	unsigned char c;

	sgCount(value);	

	c=inp(portAddr);

	return c;
}

void sgWait(void)
{

   	int n;

	for(n=0;n<period;n++)
	{

	}

}

void sgCheck(void)
{

	unsigned char romFine = True;

	char name[9];

	unsigned long int chk = 0;

	unsigned long int crt = (fBuf[0x7ffaul] + (256*fBuf[0x7ffbul]));

	unsigned char mask = (fBuf[0x7ffful] & 0x0f);

	strcpy(name,"TMR SEGA");
	
	if(!patch)
		printf("Checking ROM:\n");
	else
		printf("Patching ROM: ");

	for(m=0;m<0x7ff0;m++)
	{
		chk=chk+fBuf[m];
		chk=(chk & 0x0fffful);
	}

	if((mask != 0x0c)&&(!patch))
	{

		for(m=0x8000;m<0x20000;m++)
		{
			chk=chk+fBuf[m];
			chk=(chk & 0x0fffful);
		}
	}

	if((mask == 0x00)&&(!patch))
	{

		for(m=0x20000;m<0x40000;m++)
		{
			chk=chk+fBuf[m];
			chk=(chk & 0x0fffful);
		}
	}

	if(patch)
	{
		int i=0;
		for(i=0;i<8;i++)
		{
			fBuf[(0x7ff0ul)+i] = name[i];
		}

		fBuf[0x7ff8ul] = 0x20;
		fBuf[0x7ff9ul] = 0x00;

		fBuf[0x7ffaul] = (chk % 256);
		fBuf[0x7ffbul] = (chk / 256);
		fBuf[0x7ffcul] = 0x01;
		fBuf[0x7ffdul] = 0x50;
		fBuf[0x7ffeul] = 0x00;
		fBuf[0x7ffful] = 0x4C;

		printf("done.\n\n");
		
		return;
	}

	if(chk != crt)
	{
		printf("Warning: Checksum bad (%X, should be %X).\n",chk,crt);
		
		romFine = False;

        }

	if(!patch)
	{
		int i=0;
		for(i=0;i<8;i++)
		{
			if(fBuf[(0x7ff0ul)+i] != name[i])
			{
				printf("Warning: TMR SEGA string not present.\n");
				romFine = False;
				break;
			}
		}
	}

	if((fBuf[0x7ffful] & 0xf0) !=0x40)
	{
		printf("Warning: Country code is not 4 (US/Europe).\n");
		romFine = False;
	}

	if(romFine)
		printf("ROM is OK.\n");

	printf("\n");
	
}


void mapZero(unsigned char bank)
{
	unsigned char l;
	unsigned char n;

	if(bank > 0x03)
	{
		printf("ERROR! Null mapper cannot be used with cartridge size greater than 32K.\n\n");
		sgRemove();
		exit(1);
	}

	printf("Writing %dKBytes using null mapper.\n",ctSize[sgCart]/1024);

	printf("Writing bank                     ");

	sgReset();

	for(l=0x00;l<bank;l++)
	{

		printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l);
		
		for(m=0;m<0x4000ul;m++)
		{
			sgWrite((l*0x4000ul)+m,fBuf[(l*0x4000ul)+m]);

			if(!(m%0x400))
			{
				printf(".");
			}

		}

	}
		
	for(n=0;n<verify;n++)
	{

		printf("\n\n");

		sgSwitchOff();

		printf("Verifying cartridge.\n");

		printf("Verifying bank                     ");

		sgReset();

		for(l=0x00;l<bank;l++)
		{

			printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l);
		
			for(m=0;m<0x4000ul;m++)
			{
				if(fBuf[(l*0x4000ul)+m] != sgRead((l*0x4000ul)+m))
				{
					printf("\n\nERROR! Verify process failed. Try a slower speed setting.\n\n");

					sgRemove();

					exit(1);
				}
	
				if(!(m%0x400))
				{
					printf(".");
				}

			}

		}

	}

	printf("\n\n");

}

void mapOne(unsigned char bank)
{
	unsigned char l;
	unsigned char n;

		
	printf("Writing %dKBytes using frame 2 only mapper.\n",ctSize[sgCart]/1024);

	printf("Writing bank                     ");

	sgReset();

	for(l=0x00;l<bank;l++)
	{

		
		printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l);

		sgWrite(0xfffcul,0x00);
		sgWrite(0xfffdul,0x00);
		sgWrite(0xfffeul,0x00);
		sgWrite(0xfffful,l);

		sgReset();
		
		for(m=0;m<0x4000ul;m++)
		{
			sgWrite(0x8000ul+m,fBuf[(l*0x4000ul)+m]);

			if(!(m%0x400))
			{
				printf(".");
			}

		}

	}

	for(n=0;n<verify;n++)
	{
		printf("\n\n");

		sgSwitchOff();

		printf("Verifying cartridge.\n");

		printf("Verifying bank                     ");
		
		for(l=0x00;l<bank;l++)
		{

			sgWrite(0xfffcul,0x00);
			sgWrite(0xfffdul,0x00);
			sgWrite(0xfffeul,0x00);
			sgWrite(0xfffful,l);

			sgReset();

			printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l);
		
			for(m=0;m<0x4000ul;m++)
			{
				if(fBuf[(l*0x4000ul)+m] != sgRead((0x8000ul)+m))
				{
					printf("\n\nERROR! Verify process failed. Try a slower speed setting.\n\n");

					sgRemove();

					exit(1);
				}
	
				if(!(m%0x400))
				{
					printf(".");
				}

			}

		}

	}

	printf("\n\n");

}

void mapTwo(unsigned char bank)
{
	unsigned char l;
	unsigned char n;

		
	printf("Writing %dKBytes using dual frame mapper.\n",ctSize[sgCart]/1024);

	printf("Writing bank                     ");

	sgReset();

	for(l=0x00;l<bank;l=l+2)
	{

		
		printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l);

		sgWrite(0xfffcul,0x00);
		sgWrite(0xfffdul,0x00);
		sgWrite(0xfffeul,l);
		sgWrite(0xfffful,l+1);

		sgReset();
		
		for(m=0;m<0x4000ul;m++)
		{
			sgWrite(0x4000ul+m,fBuf[(l*0x4000ul)+m]);

			if(!(m%0x400))
			{
					printf(".");
			}

		}

		printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l+1);

		for(m=0;m<0x4000ul;m++)
		{
			sgWrite(0x8000ul+m,fBuf[((l+1)*0x4000ul)+m]);

			if(!(m%0x400))
			{
					printf(".");
			}

		}

	}

	for(n=0;n<verify;n++)
	{
		printf("\n\n");

		sgSwitchOff();

		printf("Verifying cartridge.\n");

		printf("Verifying bank                     ");

		for(l=0x00;l<bank;l=l+2)
		{

		
			printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l);

			sgWrite(0xfffcul,0x00);
			sgWrite(0xfffdul,0x00);
			sgWrite(0xfffeul,l);
			sgWrite(0xfffful,l+1);
	
			sgReset();
		
			for(m=0;m<0x4000ul;m++)
			{
				if(fBuf[(l*0x4000ul)+m] != sgRead((0x4000ul)+m))
				{
					printf("\n\nERROR! Verify process failed. Try a slower speed setting.\n\n");

					sgRemove();

					exit(1);
				}

				if(!(m%0x400))
				{
					printf(".");
				}

			}

			printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b%02X                  \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b",l+1);

			for(m=0;m<0x4000ul;m++)
			{
				if(fBuf[((l+1)*0x4000ul)+m] != sgRead((0x8000ul)+m))
				{
					printf("\n\nERROR! Verify process failed. Try a slower speed setting.\n\n");

					sgRemove();

					exit(1);
				}
	
				if(!(m%0x400))
				{
					printf(".");
				}

			}

		}

	}

	printf("\n\n");

}


void mapSram(void)
{
	unsigned char n;

	
	printf("Writing 16KBytes saved game.\n");

	printf("Writing  ");

	sgReset();

	sgWrite(0xfffcul,0x08);
	sgWrite(0xfffdul,0x00);
	sgWrite(0xfffeul,0x00);
	sgWrite(0xfffful,0x00);

	sgReset();
		
	for(m=0;m<0x4000ul;m++)
	{
		sgWrite((0x8000ul)+m,fBuf[m]);

		if(!(m%0x400))
		{
				printf(".");
		}

	}

	
	for(n=0;n<verify;n++)
	{
		printf("\n\nVerifying cartridge.\n");

		printf("Verifying  ");

		sgReset();

		sgWrite(0xfffcul,0x08);
		sgWrite(0xfffdul,0x00);
		sgWrite(0xfffeul,0x00);
		sgWrite(0xfffful,0x00);

		sgReset();
		
		for(m=0;m<0x4000ul;m++)
		{
			if(fBuf[m] != sgRead((0x8000ul)+m))
			{
				printf("\n\nERROR! Verify process failed. Try a slower speed setting.\n\n");

				sgRemove();

				exit(1);
			}

			if(!(m%0x400))
			{
				printf(".");
			}

		}

	}

	printf("\n\n");

}




void stripHeader(void)
{
	unsigned long l;
	unsigned long i = (fileLength%1024);
	

	if(i >= 512)
	{
		for(l=0;l<ctSize[sgCart];l++)
		{
			fBuf[l] = fBuf[l+512];
		}

	
	}
	
}

void fileEnter(void)
{

	fflush(stdout);

	printf("Please enter a file name : ");

	gets(fileName);

	printf("\n");

}

//END